# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()

    download_dict = {
        "windows-x64": requests.head("https://downloads.tryton.org/current/tryton-64bit-last.exe", proxies= proxies).headers[
            "Location"
        ],
        "windows-x86": requests.head("https://downloads.tryton.org/current/tryton-32bit-last.exe", proxies=proxies).headers[
            "Location"
        ],
    }

    download_url = download_dict[ensure_list(control.target_os)[0].split("(")[0] + "-" + ensure_list(control.architecture)[0]]

    latest_bin = download_url.split("/")[-1]
    version_from_url = download_url.split("/")[-2]
    latest_bin = latest_bin.replace("last", version_from_url)

    # Deleting binaries
    # remove_outdated_binaries("*")
    for f in glob.glob("*.exe"):
        if f != latest_bin:
            os.remove(f)

    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    version = version_from_url


    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating update-package-sources
    return package_updated

    # # Changing version of the package and validating update-package-sources
    # return complete_control_version(control, version)
